// Controller object
function Troller ( ) {

    // constants
    var DAY_OF_WEEK = new Array ( 'Sun' , 'Mon' , 'Tue' , 'Wed' , 'Thu' , 'Fri' , 'Sat' ) ;

    var MS_IN_SECOND = 1000 ;
    var MS_IN_MINUTE = MS_IN_SECOND * 60 ;
    var MS_IN_HOUR = MS_IN_MINUTE * 60 ;
    var MS_IN_DAY = MS_IN_HOUR * 24 ;

    // load data from preferences, if any
    // start timer
    function Setup ( ) {
		log.setup ( ) ;
		prefs.setup ( ) ;
		skills.setup ( ) ;
		account.setup ( ) ;
		completion.setup ( ) ;
    }
    this.setup = Setup ;

    // converts data given by Eve API to a JavaScript date object
    function dateFromEveDate ( eveDate ) {
		var dateStr, dParts, tParts, i, jsDate;
		var year, month, day, hour, min, sec;
		dateStr = eveDate.split( ' ' );
		dParts = dateStr[0].split( '-' );
		for ( i = 0; i < dParts.length; i++ )
			dParts[ i ] = parseInt( dParts[ i ], 10 );
		year = dParts [ 0 ];
		month = dParts [ 1 ] - 1; // js Date uses zero-based month
		day = dParts [ 2 ];		  // but not day
		tParts = dateStr[ 1 ].split( ':' );
		for ( i = 0; i < tParts.length; i++ )
			tParts[ i ] = parseInt( tParts[ i ], 10);
		hour = tParts [ 0 ];
		min = tParts [ 1 ];
		sec = tParts [ 2 ];
		jsDate = new Date(year, month, day, hour, min, sec);
		jsDate.setTime(jsDate.getTime() - (60 * jsDate.getTimezoneOffset() * 1000));
		return jsDate;
    }

    // this function is a generic function used to send an XMLHttpRequest
    // it sends using the POST method if possible, and returns XML
    function Request ( url , data , callback , returnText , useGet ) {
		var xhr = new XMLHttpRequest ( ) ;
		xhr.onreadystatechange = function ( ) {
			if ( xhr.readyState == 4 && xhr.status == 200 ) {
				var errorXML ;
				if ( xhr.responseXML )
					errorXML = xhr.responseXML.documentElement.getElementsByTagName ( 'error' ) ;
				if ( errorXML && errorXML.length > 0 ) {
					var errorText = errorXML[ 0 ].firstChild.nodeValue ;
					// error connecting... show error message
					if ( ! model.inBackground )
						ui.warning.show ( errorText ) ;
				} else if ( returnText ) {
					callback ( xhr.responseText );
				} else {
					callback ( xhr.responseXML );
				}
			} else if ( xhr.readyState == 4 ) {
				var error ;
				if ( xhr.status )
					error = 'URL: ' + url + ' returned HTTP error code: ' + xhr.status ;
				else
					error = 'Could not connect to Eve API.' ;
				if ( ! model.inBackground )
					ui.warning.show ( error ) ;
			}
		};
		
		if ( model.canUsePost && ! useGet ) {
			xhr.open ( 'POST', url ) ;
			xhr.setRequestHeader ( 'Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8' ) ;
			xhr.send ( data ) ;
		} else {
			xhr.open ( 'GET', url + '?' + data ) ;
			xhr.send ( ) ;
		}
    }

    function Prefs ( ) {
	
		function Setup ( ) {
			if ( widget.preferenceForKey ( widget.identifier + '-account' ) ) {
				Load ( ) ;
			}
		}
		this.setup = Setup ;
		
		function Load ( ) {
			var serialData = widget.preferenceForKey ( widget.identifier + '-account' ) ;
			if ( serialData ) {
				var dataParts = serialData.split ( '~' ) ;
				if ( dataParts.length > 0 ) {
					model.account.userId = dataParts[ 0 ] ;
					model.account.apiKey = dataParts[ 1 ] ;
					model.account.theme = dataParts[ 2 ] ;
					model.account.themeBackground = dataParts[ 3 ] ;
					model.account.characterName = dataParts[ 4 ] ;
					model.account.picturePath = dataParts[ 5 ] ;
					var oldPathPrefix = 'http://img.eve.is/serv.asp?s=64&c=' ;
					var newPathPrefix = 'https://image.eveonline.com/Character/' ;
					if ( model.account.picturePath.substr ( 0 , oldPathPrefix.length ) === oldPathPrefix )
						model.account.picturePath = model.account.picturePath.replace ( oldPathPrefix , newPathPrefix ) + '_64.jpg' ;
					model.account.skillName = dataParts[ 6 ] ;
					model.account.wallet = dataParts[ 7 ] * 1 ;
					model.account.totalSp = dataParts[ 8 ] * 1;
					model.account.skillFinish = new Date ( dataParts[ 9 ] ) ;
					model.account.skillFinish.setMilliseconds ( 0 ) ;
					var num = dataParts[ 10 ] * 1.00;
					model.account.trainRate = num.toFixed ( 2 ) ;
					model.account.trayOut = Boolean ( dataParts[ 11 ] * 1 ) ;
					model.account.characterId = dataParts[ 12 ] ;
					if ( dataParts.length >= 14 ) model.account.timeFormat12 = Boolean ( dataParts[ 13 ] * 1 ) ;
					// otherwise, the default value for timeFormat12 will be true (see model.js)
					if ( dataParts.length >= 15 ) model.account.nosound = Boolean ( dataParts[ 14 ] * 1 ) ;
				}
			}
		}
		this.load = Load ;
		
		function Save ( ) {
			// these are positional (see Prefs.Load)
			var dataString = model.account.userId ;
			dataString += '~' + model.account.apiKey ;
			dataString += '~' + model.account.theme ;
			dataString += '~' + model.account.themeBackground ;
			dataString += '~' + model.account.characterName ;
			dataString += '~' + model.account.picturePath ;
			dataString += '~' + model.account.skillName ;
			dataString += '~' + model.account.wallet ;
			dataString += '~' + model.account.totalSp ;
			dataString += '~' + model.account.skillFinish ;
			dataString += '~' + model.account.trainRate ;
			dataString += '~' + ( model.account.trayOut * 1 ) ;
			dataString += '~' + model.account.characterId ;
			dataString += '~' + ( model.account.timeFormat12 * 1 ) ;
			dataString += '~' + ( model.account.nosound * 1 ) ;
			widget.setPreferenceForKey ( dataString , widget.identifier + '-account' ) ;
		}
		this.save = Save ;
		
		function Remove ( ) {
			widget.setPreferenceForKey ( null , widget.identifer + '-account' ) ;
		}
		this.remove = Remove ;

    }
    var prefs = new Prefs ( ) ;
    this.prefs = prefs ;

	function Log ( ) {
	
		var _interval = null ;
		var _callback = null ;
		
		function Setup ( ) {
			if ( widget.preferenceForKey ( 'log' ) ) {
				Load ( ) ;
			}
		}
		this.setup = Setup ;

		function RunOnLock ( callback ) {
			if ( callback ) _callback = callback ;
			if ( _interval ) clearInterval ( _interval ) ;
			var lock = widget.preferenceForKey ( 'logLock' ) ;
			if ( lock == null ) {
				// could be a simultaneous write
				widget.setPreferenceForKey ( widget.identifier , 'logLock' ) ;
				// reread the lock to make sure we own it
				lock = widget.preferenceForKey ( 'logLock' ) ;
				if ( lock == widget.identifier ) { // we have it
					_callback ( ) ;
					widget.setPreferenceForKey ( null , 'logLock' ) ;
				} else { // keep checking for a free lock
					_interval = setInterval ( RunOnLock , 21 ) ;
				}
			} else { // keep checking for a free lock
				_interval = setInterval ( RunOnLock , 21 ) ;
			}
		}
		
		function _Load ( ) {
			// assumes log was already found to contains something
			// because resources were spent obtaining a lock to run this code
			var log = widget.preferenceForKey ( 'log' ) ;
			
			// kill any undefined entries
			log.replace ( '|undefined' , '' ) ;
			log.replace ( 'undefined|' , '' ) ;
			
			var entries = log.split ( '|' ) ;
			var account = entries.shift ( ) ;
			if ( account && account != 'undefined' ) {
				widget.setPreferenceForKey ( account , widget.identifier + '-account' ) ;
				prefs.load ( ) ;
				
				// kill any extra copies of this account
				var i = 0 , j = entries.length ;
				while ( i < j ) {
					if ( entries[ i ] && entries[ i ].indexOf ( model.account.userId ) != -1 ) {
						entries.splice ( i , 1 ) ; // remove entry from array
						j-- ;
					} else {
						i++ ;
					}	
				}
				
			}
			if ( entries.length > 0 )
				log = entries.join ( '|' ) ;
			else
				log = null ;
			widget.setPreferenceForKey ( log , 'log' ) ;
		}
		
		function _Save ( ) {
			var account = widget.preferenceForKey ( widget.identifier + '-account' ) ;
			if ( account ) {
				var log = widget.preferenceForKey ( 'log' ) ;
				if ( log )
					log += '|' + account ;
				else
					log = account ;
				widget.setPreferenceForKey ( log , 'log' ) ;
				prefs.remove ( ) ;
			}
		}
	
		function Load ( ) {
			RunOnLock ( _Load ) ;
		}
		this.load = Load ;

		function Save ( ) {
			RunOnLock ( _Save ) ;
		}
		this.save = Save ;
		
	}
	var log = new Log ( ) ;
	this.log = log ;

    function Version ( ) {
	
		function Callback ( text ) {
			// trim the text
			var version = text.replace ( /^\s+|\s+$/g , '' ) ;
			// test to make sure it looks like this: #.#.#
			// in case they are behind a proxy that returns a diff page
			var pattern = /^\d+\.\d+\.\d+$/ ;
			if ( pattern.test ( version ) ) {
				if ( version > VERSION ) { // VERSION should be a global
					ui.upgrade.show ( ) ;
				}
			}
		}

		function Check ( ) {
			var now = new Date ( ) ;
			if ( now.getTime ( ) > model.version.nextCheck.getTime ( ) ) {
				model.version.nextCheck.setTime ( model.version.nextCheck.getTime ( ) + MS_IN_DAY ) ;
				var url = 'http://www.cornerspeed.com/kasey/esm/esm-ver.txt';
				var data = 'nocache=' + escape ( Date ( ) ) ;
				var returnText = true ;
				var useGet = true ;
				Request ( url , data , Callback , returnText , useGet ) ;
			}
		}
		this.check = Check ;

		function Upgrade ( ) {
			model.inUpgrade = true ;
			ui.upgrade.hide ( ) ;
			widget.openURL('http://www.cornerspeed.com/kasey/esm/Eve%20Skill%20Monitor.zip');
		}
		this.upgrade = Upgrade ;

    }
    var version = new Version ( ) ; // need semi-private access
    this.version = version ; // need public access

    function Skills ( ) {

		// load skill from preference data
		function Setup ( ) {
			// get the skill expire date
			var dateString = widget.preferenceForKey ( 'skillCacheExpires' ) ;
			if ( dateString != null ) model.skills.expires = new Date ( dateString ) ;

			// parse skills from preferences
			// skillString should be of the following format
			// 12345~This Skill Name|23456~Another Skill Name
			var skillString = widget.preferenceForKey ( 'skills' ) ;
			if ( skillString != null ) {
				// skillArray should contain array of skill data items:
				// 12345~This Skill Name
				var skillArray = skillString.split ( '|' ) ;
				var i , j , skillParts , id , name ;
				for ( i = 0 , j = skillArray.length ; i < j ; i++ ) {
					skillParts = skillArray[ i ].split ( '~' ) ;
					if ( skillParts.length > 0 ) {
						id = skillParts[ 0 ] ;
						name = skillParts[ 1 ] ;
						model.skills[ id ] = name ;
					}
				}
			}
		}
		this.setup = Setup ;

		// callback to parse xml and save skill data
		function Callback ( xml ) {
			var firstSkill = true ;
			var skillListString = '' ;
			var skillSetXml = xml.documentElement.getElementsByTagName ( 'rowset' ) ;
			var i , j , iMax , jMax ;
			var skillXml , skillId , skillName , rowsetType ;
			for ( i = 0 , iMax = skillSetXml.length ; i < iMax ; i++ ) {
				rowsetType = skillSetXml[ i ].getAttribute ( 'name' ) ;
				if ( rowsetType == 'skills' ) {
					skillXml = skillSetXml[ i ].getElementsByTagName ( 'row' ) ;
					for ( j = 0 , jMax = skillXml.length ; j < jMax ; j++ ) {
						skillId = skillXml[ j ].getAttribute ( 'typeID' ) ;
						skillName = skillXml[ j ].getAttribute ( 'typeName' ) ;
						if ( skillId && skillName ) {
							if ( firstSkill )
								firstSkill = false ;
							else
								skillListString += '|' ;
							model.skills[ skillId ] = skillName ;
							skillListString += skillId + '~' + skillName ;
						}
					}
				}
			}
			if ( skillListString != '' )
				widget.setPreferenceForKey ( skillListString , 'skills' ) ;
			var cachedUntilXml = xml.documentElement.getElementsByTagName ( 'cachedUntil' ) ;
			var cachedUntil = cachedUntilXml[ 0 ].firstChild.nodeValue ;
			model.skills.expires = dateFromEveDate ( cachedUntil ) ;
			widget.setPreferenceForKey ( model.skills.expires + '' , 'skillCacheExpires' ) ;
		}

		// get new skill data if necessary
		function Update ( ) {
			var now = new Date ( ) ;
			if ( now.getTime ( ) > model.skills.expires.getTime ( ) ) {
				// set the expire date 5 minutes ahead so it doesn't keep trying to update
				model.skills.expires.setTime ( now.getTime ( ) + MS_IN_MINUTE * 5 ) ;
				var url = 'http://api.eve-online.com/eve/SkillTree.xml.aspx';
				var data = null;
				Request ( url , data , Callback ) ;
			}
		}
		this.update = Update ;
    }
    var skills = new Skills ( ) ;
    this.skills = skills ;
	
	function Completion ( ) {
	
		function Setup ( ) {
			var now = new Date ( ) ;
			if ( model.account.skillFinish.getTime ( ) > now.getTime ( ) ) {
				model.alerted = false ;
			}
		}
		this.setup = Setup ;
	
		function Alert ( ) {
			// Dashboard should now be open or opening
			//alert ( 'Skill Finished: ' + model.account.skillName + ' ' + Date ( ) ) ;
			if ( ! model.account.nosound ) {
				var sound = document.getElementById ( 'sound' ) ;
				sound.Play ( ) ;
			}
		}
		this.alert = Alert ;

		function Check ( ) {
			var now = new Date ( ) ;
			if ( now.getTime ( ) >= model.account.skillFinish.getTime ( ) && ! model.alerted ) {
				model.alerted = true ;
				var command = '/usr/bin/open /Applications/Dashboard.app' ;
				widget.system ( command , Alert ) ;
			}
		}
		this.check = Check ;
	}
	var completion = new Completion ( ) ;
	this.completion = completion ;

    // handles both front and back
    function Account ( ) {

		// private variables
		var trainUpdateStage = '' ;

		// function to put commas in appropriate places for numbers
		function Commafy ( thisNumber , keepDecimal ) {
			// split on the decimal point, if any
			var numberParts = thisNumber.toString ( ).split ( '.' ) ;
			var wholePart = numberParts[ 0 ] ;
			var decimalPart = false ;
			if ( numberParts.length > 1 ) decimalPart = numberParts[ 1 ] ;
			var i , j ;
			var commafied = '' ;
			j = wholePart.length - 1 ;
			for ( i = j ; i >= 0 ; i-- ) {
				commafied += wholePart[ j - i ] ;
				if ( i % 3 == 0 && i != 0 ) commafied += ',' ;
			}
			if ( keepDecimal && decimalPart !== false ) return commafied + '.' + decimalPart ;
			else return commafied ;
		}

		function FormattedDate ( ) {

			function sameDay ( a , b ) {
				return ( 
							a.getYear ( ) == b.getYear ( )
						 && a.getMonth ( ) == b.getMonth ( ) 
						 && a.getDate ( ) == b.getDate ( )
					   ) ;
			}

			timer.calculateTime ( ) ;
			var now = new Date ( ) ;
			var dayAhead = new Date ( ) ;
			dayAhead.setTime ( now.getTime ( ) + MS_IN_DAY ) ;
			var meridiem ;
			var hours ;

			// flags
			var today = sameDay ( now , model.account.skillFinish ) ;
			var tomorrow = sameDay ( dayAhead , model.account.skillFinish ) ;

			var formattedDate = '' ;

			if ( today ) {
				formattedDate += 'Today' ;
			} else if ( tomorrow ) {
				formattedDate += 'Tomorrow' ;
			} else {
				formattedDate += DAY_OF_WEEK[ model.account.skillFinish.getDay ( ) ] ;
				formattedDate += ' ' ;
				formattedDate += ( model.account.skillFinish.getMonth ( ) + 1 ) ; // only zero-based month is stupid
				formattedDate += '/' ;
				if ( model.account.skillFinish.getDate ( ).toString ( ).length == 1 ) formattedDate += '0' ;
				formattedDate += model.account.skillFinish.getDate ( ) + '/' + model.account.skillFinish.getFullYear ( ) ;
			}
			formattedDate += ' ' ;

			// time portion
			hours = model.account.skillFinish.getHours ( ) ;
			if ( model.account.timeFormat12 ) {
				meridiem = 'AM' ;
				if ( hours == 0 ) {
					hours = 12 ;
				} else if ( hours == 12 ) {
					meridiem = 'PM' ;
				} else if ( hours > 12 ) {
					hours -= 12 ;
					meridiem = 'PM' ;
				}
			}
			formattedDate += hours + ':' ;
			if ( model.account.skillFinish.getMinutes ( ).toString ( ).length == 1 ) formattedDate += '0' ;
			formattedDate += model.account.skillFinish.getMinutes ( ) + ':' ;
			if ( model.account.skillFinish.getSeconds ( ).toString ( ).length == 1 ) formattedDate += '0' ;
			formattedDate += model.account.skillFinish.getSeconds ( ) ;
			if ( model.account.timeFormat12 ) formattedDate += ' ' + meridiem ;
			return formattedDate ;
		}

		// load account information from model
		function Setup ( excludeBack ) {
			var theme , path ;
			if ( ! excludeBack )
				ui.account.update ( ) ;
			ui.character.update.spinner ( false ) ;
			ui.character.update.theme ( model.account.theme ) ;
			theme = themes.find ( model.account.theme ) ;
			if ( model.account.themeBackground == '' ) {
				model.account.themeBackground = theme.backgrounds[ 'Black' ] ;
			} else if ( model.account.themeBackground.length == 2 ) {
				// For accounts that upgrade. was the 'color' property
				model.account.themeBackground = 'Images/widget-bg-' + model.account.themeBackground + '.png' ;
			}
			path = themes.basePath + '/' + theme.path + '/' + model.account.themeBackground ;
			ui.character.update.background ( path ) ;
			ui.character.update.characterName ( model.account.characterName ) ;
			ui.character.update.skillName ( model.account.skillName ) ;
			ui.character.update.characterPic ( model.account.picturePath ) ;
			ui.character.update.wallet ( Commafy ( model.account.wallet ) ) ;
			ui.character.update.totalSp ( Commafy ( model.account.totalSp ) ) ;
			ui.character.update.skillFinish ( FormattedDate ( ) ) ;
			ui.character.update.trainRate ( Commafy ( model.account.trainRate , true ) ) ;
			ui.character.update.trayState ( model.account.trayOut ) ;
		}
		this.setup = Setup ;

		// function called when done is pressed on back of widget
		function Save ( ) {
			// check to see if they changed anything
			var userId = ui.account.userId ( ) ;
			var apiKey = ui.account.apiKey ( ) ;
			var theme = ui.account.theme ( ) ;
			var themeBackground = ui.account.themeBackground ( ) ;
			var nosound = ui.account.nosound ( ) ;

			if ( nosound != model.account.nosound ) {
				model.account.nosound = nosound ;
				model.hasChanged = true ;
			}

			var themeChanged = (theme != model.account.theme);
			if ( themeChanged ) {
				model.account.theme = theme ;
				ui.character.update.theme ( theme ) ;
				model.hasChanged = true ;
			}

			if ( themeBackground != model.account.themeBackground || themeChanged ) {
				model.account.themeBackground = themeBackground ;
				var themeObj = themes.find ( theme ) ;
				var path = themes.basePath + '/' + themeObj.path + '/' + themeBackground ;
				// load the image
				ui.character.update.background ( path ) ;
				model.hasChanged = true ;
			}

			if ( userId != model.account.userId || apiKey != model.account.apiKey ) {
				model.hasChanged = true ;
				model.account.userId = userId ;
				model.account.apiKey = apiKey ;
				model.account.characterId = '' ;
				model.timer.charDataExpire = new Date ( ) ;
				model.timer.charDataExpire.setTime ( model.timer.charDataExpire.getTime ( ) + MS_IN_SECOND ) ;
				model.timer.trainDataExpire = new Date ( ) ;
			}

			ui.character.show ( ) ;
		}
		this.save = Save ;
		
		function ToggleTimeFormat ( ) {
			model.account.timeFormat12 = ! model.account.timeFormat12 ;
			model.hasChanged = true ;
			ui.character.update.skillFinish ( FormattedDate ( model.account.skillFinish ) ) ;
		}
		this.toggleTimeFormat = ToggleTimeFormat ;

		function ToggleTray ( value ) {
			if ( model.account.trayOut != value ) {
				model.account.trayOut = value ;
				model.hasChanged = true ;
			}
		}
		this.toggleTray = ToggleTray ;

		// updates training and character information
		function Update ( ) {

			// function to start the training data update process
			function GetCharacterListAndCascade ( ) {

				function ParseCharacterList ( apiXML ) {

					var charXML = apiXML.documentElement.getElementsByTagName( 'row' );
					var i, tmpCharID, tmpCharName;

					for ( i = 0; i < charXML.length; i++ ) {
						tmpCharID = charXML[i].getAttribute( 'characterID' );
						tmpCharName = charXML[i].getAttribute( 'name' );
						model.characters[ tmpCharID ] = tmpCharName ;
						GetTraining ( tmpCharID );
					}

				}

				trainUpdateStage = 'char list' ;
				
				model.charactersTraining = 0 ;

				var url = 'http://api.eve-online.com/account/Characters.xml.aspx';
				var data = 'userID=' + model.account.userId + '&apiKey=' + model.account.apiKey ;
				Request ( url , data , ParseCharacterList ) ;

			}

			// gets the training information for a given character
			function GetTraining ( characterId ) {

				function ParseTraining ( apiXML ) {

					var trainXML = apiXML.documentElement ;
					var isTrainingXML = trainXML.getElementsByTagName ( 'skillInTraining' ) ;
					var isTraining = isTrainingXML[ 0 ].firstChild.nodeValue ;

					if ( isTraining == "1" ) {
					
						model.charactersTraining++ ;

						var now = new Date ( ) ;
						var endTimeXML = trainXML.getElementsByTagName ( 'trainingEndTime' ) ;
						var endTime = endTimeXML[ 0 ].firstChild.nodeValue ;
						var newSkillFinish = dateFromEveDate ( endTime ) ;
						newSkillFinish.setMilliseconds ( 0 ) ; // round off milliseconds, if any


						/* IF CONDITION INFO
						 * PURPOSE:
						 *   Eve API may return data for multiple characters training at same time
						 * SCENARIO:
						 *   Account has Character A training
						 *   Character A finishes training
						 *   Character A is not logged on after skill finishes
						 *   Character B on the account starts training
						 *   Eve API will return
						 *     Character A is training a skill with a finish time in the past
						 *     Character B is training a skill with a future finish time
						 * TRUTH CONDITIONS:
						 *   1) the first set of training data (even if skill finish time is past)
						 *   2) second or third data set and finish time is later than the current skill's
						 */

						if	( 
									model.charactersTraining < 2 
								||	newSkillFinish.getTime ( ) > model.account.skillFinish.getTime ( )
							)
						{

							if ( model.account.characterId != characterId ) {
								model.account.characterId = characterId ;
								model.timer.charDataExpire = new Date ( ) ; // data expires now
								model.timer.charDataExpire.setTime ( model.timer.charDataExpire.getTime ( ) + MS_IN_SECOND ) ;
								model.account.picturePath = 'https://image.eveonline.com/Character/' + characterId + '_64.jpg' ;
								model.hasChanged = true ;
							}

							// if they are disconnected the first time, but still training the same character
							// this will never get set if it's in the if block above
							if ( ! model.inBackground )
								ui.character.update.characterPic ( model.account.picturePath ) ;

							// character name could have changed... maybe?
							model.account.characterName = model.characters[ characterId ] ;
							if ( ! model.inBackground )
								ui.character.update.characterName ( model.account.characterName ) ;

							var nextUpdateXML = trainXML.getElementsByTagName ( 'cachedUntil' ) ;
							var nextUpdate = nextUpdateXML[ 0 ].firstChild.nodeValue;
							model.timer.trainDataExpire = dateFromEveDate ( nextUpdate ) ;

							var startTimeXML = trainXML.getElementsByTagName ( 'trainingStartTime' ) ;
							var startTime = startTimeXML[ 0 ].firstChild.nodeValue ;
							var skillStart = dateFromEveDate ( startTime ) ;

							if ( model.account.skillFinish.getTime ( ) != newSkillFinish.getTime ( ) ) {
								model.account.skillFinish = newSkillFinish ;
								model.hasChanged = true ;
							}
							if ( ! model.inBackground )
								ui.character.update.skillFinish ( FormattedDate ( model.account.skillFinish ) ) ;
							// the timer will update itself

							var startSpXML = trainXML.getElementsByTagName ( 'trainingStartSP' ) ;
							var startSp = startSpXML[ 0 ].firstChild.nodeValue * 1 ;

							var endSpXML = trainXML.getElementsByTagName ( 'trainingDestinationSP' ) ;
							var endSp = endSpXML[ 0 ].firstChild.nodeValue * 1 ;

							var newTrainRate = ( endSp - startSp ) / ( ( model.account.skillFinish.getTime ( ) - skillStart.getTime ( ) ) / MS_IN_HOUR ) ;
							// round to two digits
							newTrainRate = newTrainRate.toFixed ( 2 ) ;
							if ( newTrainRate != model.account.trainRate ) {
								model.account.trainRate = newTrainRate ;
								if ( ! model.inBackground )
									ui.character.update.trainRate ( Commafy ( model.account.trainRate , true ) ) ;
								model.hasChanged = true ;
							}

							var skillIdXML = trainXML.getElementsByTagName( 'trainingTypeID' );
							var skillId = skillIdXML[ 0 ].firstChild.nodeValue;
							var skillLevelXML = trainXML.getElementsByTagName( 'trainingToLevel' );
							var skillLevel = skillLevelXML[ 0 ].firstChild.nodeValue;

							var skillLevelRoman ;
							switch ( skillLevel ) {
								case '1': skillLevelRoman = 'I' ;
								break ;
								case '2': skillLevelRoman = 'II' ;
								break ;
								case '3': skillLevelRoman = 'III' ;
								break ;
								case '4': skillLevelRoman = 'IV' ;
								break ;
								case '5': skillLevelRoman = 'V' ;
								break ;
							}

							var newSkillName = model.skills[ skillId ] + ' ' + skillLevelRoman ;
							if ( newSkillName != model.account.skillName ) {
								model.account.skillName = newSkillName ;
								if ( ! model.inBackground )
									ui.character.update.skillName ( model.account.skillName ) ;
								model.hasChanged = true ;
							}
							if ( model.hasChanged ) model.alerted = false ;
							if ( ! model.inBackground )
								ui.character.update.spinner ( false ) ;
						}
					}

				}

				trainUpdateStage = 'train info' ;

				var url = 'http://api.eve-online.com/char/SkillInTraining.xml.aspx';
				var data = 'userID=' + model.account.userId + '&apiKey=' + model.account.apiKey ;
				data += '&characterID=' + characterId;

				Request ( url , data , ParseTraining ) ;

			}

			// starts character data update process
			function GetCharacterData ( ) {

				function ParseCharacterData ( apiXML ) {

					var charXML = apiXML.documentElement.getElementsByTagName ( 'result' );

					var balanceXML = charXML[ 0 ].getElementsByTagName ( 'balance' );
					var balance = balanceXML[ 0 ].firstChild.nodeValue * 1.00 ;
					if ( model.account.wallet != balance ) {
						model.account.wallet = balance ;
						if ( ! model.inBackground )
							ui.character.update.wallet ( Commafy ( model.account.wallet ) ) ;
						model.hasChanged = true ;
					}

					var skillsXML = charXML[ 0 ].getElementsByTagName ( 'row' ) ;
					var i , j , sp , totalSp ;
					totalSp = 0 ;
					for ( i = 0 , j = skillsXML.length ; i < j ; i++ ) {
						if ( sp = skillsXML[ i ].getAttribute ( 'skillpoints' ) * 1 ) {
							totalSp += sp ;
						}
					}
					if ( totalSp != model.account.totalSp ) {
						model.account.totalSp = totalSp ;
						if ( ! model.inBackground )
							ui.character.update.totalSp ( Commafy ( model.account.totalSp ) ) ;
						model.hasChanged = true ;
					}
				}

				var url = 'http://api.eve-online.com/char/CharacterSheet.xml.aspx';
				var data = 'userID=' + model.account.userId + '&apiKey=' + model.account.apiKey + '&characterID=' + model.account.characterId ;

				Request ( url , data , ParseCharacterData ) ;

			}

			// lazy saving to avoid hitting preferences too much
			// save preferences if there has been a change in data
			if ( model.hasChanged ) {
				model.hasChanged = false ;
				prefs.save ( ) ;
			}

			var now = new Date ( ) ;
			if ( now.getTime ( ) > model.timer.trainDataExpire.getTime ( ) && model.account.userId && model.account.apiKey ) {
				if ( ! model.inBackground )
					ui.character.update.spinner ( true ) ;
				model.timer.trainDataExpire.setTime ( model.timer.trainDataExpire.getTime ( ) + ( MS_IN_MINUTE * 5 ) ) ;
				GetCharacterListAndCascade ( ) ;
			}

			if ( now.getTime ( ) > model.timer.charDataExpire.getTime ( ) && model.account.characterId != '' ) {
				model.timer.charDataExpire.setTime ( model.timer.charDataExpire.getTime ( ) + ( MS_IN_MINUTE * 5 ) ) ;
				GetCharacterData ( ) ;
			}
		}
		this.update = Update ;
    }
    var account = new Account ( ) ;
    this.account = account ;

    function Timer ( ) {
		var interval ; // variable for holding interval

		function CalculateTime ( ) {
			var thisFinishTimeMs = model.account.skillFinish.getTime ( ) ;
			var now = new Date ( ) ;
			var timeLeft = thisFinishTimeMs - now.getTime ( ) ;
			var days = 0 , hours = 0 , minutes = 0 , seconds = 0 ;
			if (timeLeft > 0 ) {
				// calculate timer values
				days = Math.floor ( timeLeft / MS_IN_DAY ) ;
				timeLeft -= days * MS_IN_DAY ;
				hours = Math.floor ( timeLeft / MS_IN_HOUR ) ;
				timeLeft -= hours * MS_IN_HOUR ;
				minutes = Math.floor ( timeLeft / MS_IN_MINUTE ) ;
				timeLeft -= minutes * MS_IN_MINUTE ;
				seconds = Math.round ( timeLeft / MS_IN_SECOND ) ;
			}
			model.timer.days = days ;
			model.timer.hours = hours ;
			model.timer.minutes = minutes ;
			model.timer.seconds = seconds ;
		}
		this.calculateTime = CalculateTime ;

		// starts the timer
		function Start ( ) {
			Update ( ) ;
			if ( ! interval ) interval = setInterval ( Update , 1000) ;
		}
		this.start = Start ;

		// stops the timer
		function Stop ( ) {
			if ( interval ) {
				clearInterval ( interval ) ;
				interval = null;
			}
		}
		this.stop = Stop ;
		
		// puts the widget in silent mode
		function Pause ( ) {
			Stop ( ) ;
			if ( ! interval ) interval = setInterval ( Update , 60000) ;
			model.inBackground = true ;
		}
		this.pause = Pause ;
		
		// takes the widget out of silent mode
		function Unpause ( ) {
			Stop ( ) ;
			model.inBackground = false ;
			account.setup ( true ) ; // call this in case skills were changed while we were silent
			Start ( ) ;
		}
		this.unpause = Unpause ;

		// updates any information that may need it
		function Update ( ) {
			// check for data updates
			if ( ! model.inBackground ) 
				version.check ( ) ;
			skills.update ( ) ;
			account.update ( ) ;
			completion.check ( ) ;

			// update the timer
			if ( ! model.inBackground ) {
				CalculateTime ( ) ;
				ui.character.update.timer ( ) ;
			}
		}
    }
    var timer = new Timer ( ) ;
    this.timer = timer ;

}
