function UI ( ) {

    function isLoaded ( img ) {
		var testImg = new Image ( ) ;
		testImg.src = img.src ;
		return testImg.complete ;
    }
	
    // initialize UI objects
    function Setup ( ) {
		warning.setup ( ) ;
		upgrade.setup ( ) ;
		account.setup ( ) ;
		character.setup ( ) ;
    }
    this.setup = Setup ;

    // Warning UI object
    function Warning ( ) {

		var warningDismiss ; // Glass button

		function Setup ( ) {
			warningDismiss = new AppleGlassButton ( document.getElementById ( 'warningDismiss' ) , 'OK' , Dismiss ) ;
		}
		this.setup = Setup ;

		function Show ( text ) {
			var warningDiv = document.getElementById ( 'warning' ) ;
			var warningText = document.getElementById ( 'warningText' ) ;
			warningText.innerHTML = text ;
			warningDiv.style.display = 'block' ;
		}
		this.show = Show ;

		function Dismiss ( ) {
			var warningDiv = document.getElementById ( 'warning' ) ;
			warningDiv.style.display = 'none' ;
		}
		this.dismiss = Dismiss ;

    }
    var warning = new Warning ( ) ;
    this.warning = warning ;

    // Version UI object
    function Upgrade ( ) {

		var updateYes , updateNo ;

		function Setup ( ) {
			// setup versionText
			var versionText = document.getElementById ( 'versionText' ) ;
			versionText.innerHTML = 'v' + VERSION ; // should be defined as a global
			versionText.onclick = troller.version.check ;
			// create buttons
			upgradeYes = new AppleGlassButton ( document.getElementById ( 'upgradeYes' ) , 'Yes' , troller.version.upgrade ) ;
			upgradeNo = new AppleGlassButton ( document.getElementById ( 'upgradeNo' ) , 'No' , Hide ) ;
		}
		this.setup = Setup ;

		function Show ( ) {
			var versionText = document.getElementById ( 'versionText' ) ;
			versionText.style.color = '#fc9' ;
			var upgrade = document.getElementById ( 'upgrade' ) ;
			upgrade.style.display = 'block' ;
		}
		this.show = Show ;

		function Hide ( ) {
			var upgrade = document.getElementById ( 'upgrade' ) ;
			upgrade.style.display = 'none' ;
		}
		this.hide = Hide ;

    }
    var upgrade = new Upgrade ( ) ;
    this.upgrade = upgrade ;

    // Account object for the back of the widget
    function Account ( ) {

		var doneButton ;

		// load the themes into the drop-down list
		// load the default theme's backgrounds into the drop-down list
		function Setup ( ) {
			doneButton = new AppleGlassButton ( document.getElementById ( 'doneButton' ) , 'Done' , troller.account.save ) ;
			
			var themeTag = document.getElementById ( 'theme' ) ;
			themeTag.options.length = 0 ; // clear the options
			var i , j , theme , option , defaultSelected ;
			for ( i = 0 , j = themes.list.length ; i < j ; i++ ) {
				theme = themes.list[ i ] ;
				if ( themes.defaultValue == theme.cssName ) defaultSelected = true ;
				else defaultSelected = false ;
				option = null ;
				option = new Option ( theme.name , theme.cssName , defaultSelected ) ;
				themeTag.options[ i ] = option ;
			}
			// load the default theme's backgrounds
			ChangeTheme ( ) ;
		}
		this.setup = Setup ;

		// flip
		function Show ( ) {
			troller.timer.stop ( ) ;
			var front = document.getElementById ( 'front' ) ;
			var back = document.getElementById ( 'back' ) ;

			if ( window.widget ) widget.prepareForTransition ( 'ToBack' ) ;

			front.style.display = 'none' ;
			back.style.display = 'block' ;

			window.resizeTo ( 326 , 126 ) ;

			if ( window.widget ) setTimeout ( 'widget.performTransition ( ) ;' , 0 ) ;
		}
		this.show = Show ;

		function UserId ( ) {
			var userId = document.getElementById ( 'userId' ) ;
			return userId.value ;
		}
		this.userId = UserId ;

		function ApiKey ( ) {
			var apiKey = document.getElementById ( 'apiKey' ) ;
			return apiKey.value ;
		}
		this.apiKey = ApiKey ;
		
		function Theme ( ) {
			var theme = document.getElementById ( 'theme' ) ;
			return theme.options[ theme.selectedIndex ].value ;
		}
		this.theme = Theme ;

		function ThemeBackground ( ) {
			var themeBackground = document.getElementById ( 'themeBackground' ) ;
			return themeBackground.options[ themeBackground.selectedIndex ].value ;
		}
		this.themeBackground = ThemeBackground ;
		
		function NoSound ( ) {
			var nosoundTag = document.getElementById ( 'nosound' ) ;
			if ( nosoundTag.src.match('muteon.png') != null ) return true ;
			else return false ;
		}
		this.nosound = NoSound ;

		function ChangeTheme ( ) {
			var themeTag = document.getElementById ( 'theme' ) ;
			var themeBackgroundTag = document.getElementById ( 'themeBackground' ) ;
			themeBackgroundTag.options.length = 0 ;
			var selectedTheme = themeTag.options[ themeTag.selectedIndex ].value ;
			var theme = themes.find ( selectedTheme ) ;
			// change the themeBackground options
			var backgroundName , backgroundPath , bgOption , bgOptionCount ;
			for ( backgroundName in theme.backgrounds ) {
				bgOptionCount = themeBackgroundTag.options.length ;
				backgroundPath = theme.backgrounds[ backgroundName ] ;
				bgOption = null ;
				bgOption = new Option ( backgroundName , backgroundPath , false ) ;
				themeBackgroundTag.options[ bgOptionCount ] = bgOption ;
			}
		}
		this.changeTheme = ChangeTheme ;
		
		function ToggleSound ( ) {
			var soundTag = document.getElementById ( 'nosound' ) ;
			if ( NoSound ( ) )
				soundTag.src = 'Images/muteoff.png';
			else
				soundTag.src = 'Images/muteon.png' ;
		}
		this.toggleSound = ToggleSound ;

		// update display from model data
		function Update ( ) {
			var userId = document.getElementById ( 'userId' ) ;
			var apiKey = document.getElementById ( 'apiKey' ) ;
			var theme = document.getElementById ( 'theme' ) ;
			var themeBackground = document.getElementById ( 'themeBackground' ) ;
			var nosoundTag = document.getElementById ( 'nosound' ) ;
			userId.value = model.account.userId ;
			apiKey.value = model.account.apiKey ;
			if ( NoSound ( ) != model.account.nosound ) ToggleSound ( ) ;
			
			var selectedTheme = theme.options[ theme.selectedIndex ].value ;
			
			var i , j , found ;
			if ( model.account.theme != selectedTheme ) {
				// update the theme
				for ( i = 0 , j = theme.options.length , found = false ; i < j && ! found ; i++ ) {
					if ( theme.options[ i ].value == model.account.theme ) {
						theme.options[ i ].selected = true ;
						found = true ;
					}
				}
				ChangeTheme ( ) ;
			}
			
			var selectedThemeBg = themeBackground.options[ themeBackground.selectedIndex ].value ;
			if ( model.account.themeBackground != selectedThemeBg ) {
				for ( i = 0 , j = themeBackground.options.length , found = false ; i < j && ! found ; i++ ) {
					if ( themeBackground.options[ i ].value == model.account.themeBackground ) {
						themeBackground.options[ i ].selected = true ;
						found = true ;
					}
				}
			}
		}
		this.update = Update ;

    }
    var account = new Account ( ) ;
    this.account = account ;

    // character and training display object
    function Character ( ) {

		var infoButton ;

		function Setup ( ) {
		
			function Preload ( imgPath ) {
				var image ;
				var preloads = document.getElementById ( 'preloads' ) ;
				image = null ;
				image = document.createElement ( 'img' ) ;
				image.src = imgPath ;
				preloads.appendChild ( image ) ;
			}
		
			infoButton = new AppleInfoButton ( document.getElementById ( 'infoButton' ) , document.getElementById ( 'front' ) , 'white' , 'white' , account.show ) ;
			
			// load the themes
			var i , j , theme , themePath ;
			for ( i = 0 , j = themes.list.length ; i < j ; i++ ) {
				theme = null ;
				theme = themes.list[ i ] ;
				themePath = themes.basePath + '/' + theme.path ;
				// preload images
				Preload ( themePath + '/' + theme.bgShadow ) ;
				Preload ( themePath + '/' + theme.bgOverlay ) ;
				Preload ( themePath + '/' + theme.timer ) ;
				Preload ( themePath + '/' + theme.overlay ) ;
				Preload ( themePath + '/' + theme.spinner ) ;
				Preload ( themePath + '/' + theme.tray ) ;
				for ( backgroundName in theme.backgrounds ) {
					Preload ( themePath + '/' + theme.backgrounds[ backgroundName ] ) ;
				}
			}
		}
		this.setup = Setup ;

		function Show ( ) {
			troller.timer.start ( ) ;
			var front = document.getElementById ( 'front' ) ;
			var back = document.getElementById ( 'back' ) ;

			// have to start this early or else it might not completely render the tray
			if ( model.account.trayOut ) window.resizeTo ( 328 , 178 ) ;

			if ( window.widget ) widget.prepareForTransition ( 'ToFront' ) ;

			back.style.display = 'none' ;
			front.style.display = 'block' ;

			if ( ! model.account.trayOut ) window.resizeTo ( 328 , 113 ) ;

			if ( window.widget ) setTimeout ( 'widget.performTransition ( ) ;' , 0 ) ;
		}
		this.show = Show ;

		function Update ( ) {

			function UpdateValue ( elementName , value ) {
				var element = document.getElementById ( elementName ) ;
				element.innerHTML = value ;
			}

			function UpdateSource ( elementName , path ) {
				var element = document.getElementById ( elementName ) ;
				element.src = '' ;
				element.src = path ;
			}

			function UpdateVisible ( elementName , visible ) {
				var element = document.getElementById ( elementName ) ;
				if ( visible ) element.style.display = 'block' ;
				else element.style.display = 'none' ;
			}

			function Spinner ( visible ) {
				UpdateVisible ( 'spinner' , visible ) ;
			}
			this.spinner = Spinner ;
			
			function Theme ( themeCssName ) {
				// set the front's CSS class
				var front = document.getElementById ( 'front' ) ;
				front.className = themeCssName ;
				// get the theme object to use for the images
				var theme = themes.find ( themeCssName ) ;
				var themePath = themes.basePath + '/' + theme.path ;
				// set all the theme images
				var bgShadow = document.getElementById ( 'bgShadow' ) ;
				var bgOverlay = document.getElementById ( 'bgOverlay' ) ;
				var timerFace = document.getElementById ( 'timerFace' ) ;
				var overlay = document.getElementById ( 'overlay' ) ;
				var spinner = document.getElementById ( 'spinner' ) ;
				var trayBg = document.getElementById ( 'trayBg' ) ;
				bgShadow.src = themePath + '/' + theme.bgShadow ;
				bgOverlay.src = themePath + '/' + theme.bgOverlay ;
				timerFace.src = themePath + '/' + theme.timer ;
				overlay.src = themePath + '/' + theme.overlay ;
				spinner.src = themePath + '/' + theme.spinner ;
				trayBg.src = themePath + '/' + theme.tray ;
			}
			this.theme = Theme ;

			function Background ( path ) {
				UpdateSource ( 'background' , path ) ;
			}
			this.background = Background ;

			function CharacterName ( value ) {
				UpdateValue ( 'characterName' , value ) ;
			}
			this.characterName = CharacterName ;

			function SkillName ( value ) {
				UpdateValue ( 'skillName' , value ) ;
			}
			this.skillName = SkillName ;

			function CharacterPic ( path ) {
				// special handling because we don't want to pull from the Eve img server too much
				var characterPic = document.getElementById ( 'characterPic' ) ;
				if ( ! isLoaded ( characterPic ) || characterPic.src != path ) {
					UpdateSource ( 'characterPic' , path ) ;
				}
			}
			this.characterPic = CharacterPic ;

			function Timer ( ) {
				UpdateValue ( 'days' , model.timer.days ) ;
				UpdateValue ( 'hours' , model.timer.hours ) ;
				UpdateValue ( 'minutes' , model.timer.minutes ) ;
				UpdateValue ( 'seconds' , model.timer.seconds ) ;
			}
			this.timer = Timer ;

			function Wallet ( value ) {
				UpdateValue ( 'wallet' , value + ' ISK' ) ;
			}
			this.wallet = Wallet ;

			function TotalSp ( value ) {
				UpdateValue ( 'totalSp' , value + ' SP' ) ;
			}
			this.totalSp = TotalSp ;

			function SkillFinish ( value ) {
				UpdateValue ( 'skillFinish' , value ) ;
			}
			this.skillFinish = SkillFinish ;

			function TrainRate ( value ) {
				UpdateValue ( 'trainRate' , value + ' SP / hr' ) ;
			}
			this.trainRate = TrainRate ;

			function TrayState ( visible ) {
				if ( visible ) window.resizeTo ( 328 , 178 ) ;
				else window.resizeTo ( 328 , 113 ) ;
				UpdateVisible ( 'tray' , visible ) ;
			}
			this.trayState = TrayState ;

		}
		this.update = new Update ( ) ;

    }
    var character = new Character ( ) ;
    this.character = character ;

    // object for manipulating tray extension
    function Tray ( ) {
	
		function Toggle ( ) {

			var isOut = false ;
			var traySlideAnimator ;

			// function to perform height and placement adjustments for slide animation
			// called from traySlideAnimator, an AppleAnimator class
			function TraySlide ( animation , current , start , finish ) {
				var tray = document.getElementById ( 'tray' ) ;
				tray.style.top = current + 'px' ;
				tray.style.height = ( current + 78 ) + 'px' ;
				if ( current == -78 && start == 0 ) {
					tray.style.display = 'none';
					window.resizeTo ( 328 , 113 ) ;
				}
			} // private, called from traySlideAnimator object

			var tray = document.getElementById ( 'tray' ) ;
			if ( tray.style.display == 'block') {
				traySlideAnimator = new AppleAnimator ( 500 , 13 , 0 , -78 , TraySlide ) ;
				traySlideAnimator.start ( ) ;
				isOut = false ;
			} else if ( tray.style.display == 'none' || tray.style.display == '' ) { // is empty on first call
				tray.style.top = '-78px' ;
				tray.style.height = '0px' ;
				tray.style.display = 'block' ;
				// AppleAnimator(duration, interval, start, finish, handler)
				traySlideAnimator = new AppleAnimator ( 500 , 13 , -78 , 0 , TraySlide ) ;
				traySlideAnimator.start ( ) ;
				isOut = true ;
			}
			if ( isOut ) window.resizeTo ( 328 , 178 ) ;
			troller.account.toggleTray ( isOut ) ;
		}
		this.toggle = Toggle ;
    }
    var tray = new Tray ( ) ;
    this.tray = tray ;

}
